### (C) 2014 Narazaka : Licensed under The MIT License - http://narazaka.net/license/MIT?2014 ###

http = require 'http'
socket_io = require 'socket.io'
url = require 'url'
fs = require 'fs'
path = require 'path'
execFile = require('child_process').execFile

module.exports =
	miyopreview_demo_httpserver_open_browser:
		type: 'through', filter: (argument, request, id, stash) ->
			setTimeout (=>
				child = execFile 'C:/Program Files/Internet Explorer/IEXPLORE.EXE', ['http://localhost:9802/']
				@variables_temporary.miyopreview_demo_httpserver_browser = child
			) , 0
			argument
	miyopreview_demo_httpserver_close_browser:
		type: 'through', filter: (argument, request, id, stash) ->
			@variables_temporary.miyopreview_demo_httpserver_browser.kill()
			delete @variables_temporary.miyopreview_demo_httpserver_browser
			argument
	miyopreview_demo_httpserver_start:
		type: 'through', filter: (argument, request, id, stash) ->
			docroot = path.join process.cwd(), 'rc', 'htdocs'
			content_types =
				html: 'text/html'
				css: 'text/css'
				js: 'text/javascript'
				txt: 'text/plain'
			response_contents =
				200: (response, content, filepath) ->
					ext = path.extname(filepath).replace /^\./, ''
					headers = {}
					if content_types[ext]
						headers['Content-Type'] = content_types[ext]
					response.writeHead 200, headers
					response.write content, 'binary'
					response.end()
				404: (response, content) ->
					response.writeHead 404,
						'Content-Type': 'text/plain'
					response.write '404 Not Found\n'
					response.end()
				500: (response, error) ->
					response.writeHead 500,
						'Content-Type': 'text/plain'
					response.write '500 Internal Server Error\n\n' + error + '\n'
					response.end()
			onRequest = (request, response) ->
				uri = url.parse(request.url).pathname
				filepath = path.join docroot, uri
				fs.exists filepath, (exists) ->
					if not exists
						response_contents[404] response
					else
						if fs.statSync(filepath).isDirectory()
							filepath = path.join filepath, 'index.html'
						fs.readFile filepath, 'binary', (error, content) ->
							if error
								response_contents[500] response, error
							else
								response_contents[200] response, content, filepath
			setTimeout (=>
				server = http.createServer(onRequest).listen(9802)
				@variables_temporary.miyopreview_demo_httpserver_server = server
				sio = socket_io.listen server
				@variables_temporary.miyopreview_demo_httpserver_socket_io = sio
				sio.on 'connection', (socket) =>
					socket.on 'speak', (data) =>
						original_event = @dictionary.OnSecondChange
						@dictionary.OnSecondChange =
							filters: 'miyopreview_demo_httpserver_speak'
							argument:
								miyopreview_demo_httpserver_speak:
									original: original_event
									content: data
				original_request = @request
				@request = (request) =>
					sio.emit 'shiori_request', request.toString()
					response = original_request.call @, request
					sio.emit 'shiori_response', response.toString()
					return response
				sio.on 'close', =>
					@request = original_request
			), 0
			argument
	miyopreview_demo_httpserver_stop:
		type: 'through', filter: (argument, request, id, stash) ->
			@variables_temporary.miyopreview_demo_httpserver_socket_io.close()
			delete @variables_temporary.miyopreview_demo_httpserver_socket_io
			delete @variables_temporary.miyopreview_demo_httpserver_server
			argument
	miyopreview_demo_httpserver_speak:
		type: 'data-value', filter: (argument, request, id, stash) ->
			options = argument.miyopreview_demo_httpserver_speak
			@dictionary.OnSecondChange = options.original
			return options.content
