// Generated by CoffeeScript 1.8.0

/* (C) 2014 Narazaka : Licensed under The MIT License - http://narazaka.net/license/MIT?2014 */

(function() {
  var execFile, fs, http, path, socket_io, url;

  http = require('http');

  socket_io = require('socket.io');

  url = require('url');

  fs = require('fs');

  path = require('path');

  execFile = require('child_process').execFile;

  module.exports = {
    miyopreview_demo_httpserver_open_browser: {
      type: 'through',
      filter: function(argument, request, id, stash) {
        setTimeout(((function(_this) {
          return function() {
            var child;
            child = execFile('C:/Program Files/Internet Explorer/IEXPLORE.EXE', ['http://localhost:9802/']);
            return _this.variables_temporary.miyopreview_demo_httpserver_browser = child;
          };
        })(this)), 0);
        return argument;
      }
    },
    miyopreview_demo_httpserver_close_browser: {
      type: 'through',
      filter: function(argument, request, id, stash) {
        this.variables_temporary.miyopreview_demo_httpserver_browser.kill();
        delete this.variables_temporary.miyopreview_demo_httpserver_browser;
        return argument;
      }
    },
    miyopreview_demo_httpserver_start: {
      type: 'through',
      filter: function(argument, request, id, stash) {
        var content_types, docroot, onRequest, response_contents;
        docroot = path.join(process.cwd(), 'rc', 'htdocs');
        content_types = {
          html: 'text/html',
          css: 'text/css',
          js: 'text/javascript',
          txt: 'text/plain'
        };
        response_contents = {
          200: function(response, content, filepath) {
            var ext, headers;
            ext = path.extname(filepath).replace(/^\./, '');
            headers = {};
            if (content_types[ext]) {
              headers['Content-Type'] = content_types[ext];
            }
            response.writeHead(200, headers);
            response.write(content, 'binary');
            return response.end();
          },
          404: function(response, content) {
            response.writeHead(404, {
              'Content-Type': 'text/plain'
            });
            response.write('404 Not Found\n');
            return response.end();
          },
          500: function(response, error) {
            response.writeHead(500, {
              'Content-Type': 'text/plain'
            });
            response.write('500 Internal Server Error\n\n' + error + '\n');
            return response.end();
          }
        };
        onRequest = function(request, response) {
          var filepath, uri;
          uri = url.parse(request.url).pathname;
          filepath = path.join(docroot, uri);
          return fs.exists(filepath, function(exists) {
            if (!exists) {
              return response_contents[404](response);
            } else {
              if (fs.statSync(filepath).isDirectory()) {
                filepath = path.join(filepath, 'index.html');
              }
              return fs.readFile(filepath, 'binary', function(error, content) {
                if (error) {
                  return response_contents[500](response, error);
                } else {
                  return response_contents[200](response, content, filepath);
                }
              });
            }
          });
        };
        setTimeout(((function(_this) {
          return function() {
            var original_request, server, sio;
            server = http.createServer(onRequest).listen(9802);
            _this.variables_temporary.miyopreview_demo_httpserver_server = server;
            sio = socket_io.listen(server);
            _this.variables_temporary.miyopreview_demo_httpserver_socket_io = sio;
            sio.on('connection', function(socket) {
              return socket.on('speak', function(data) {
                var original_event;
                original_event = _this.dictionary.OnSecondChange;
                return _this.dictionary.OnSecondChange = {
                  filters: 'miyopreview_demo_httpserver_speak',
                  argument: {
                    miyopreview_demo_httpserver_speak: {
                      original: original_event,
                      content: data
                    }
                  }
                };
              });
            });
            original_request = _this.request;
            _this.request = function(request) {
              var response;
              sio.emit('shiori_request', request.toString());
              response = original_request.call(_this, request);
              sio.emit('shiori_response', response.toString());
              return response;
            };
            return sio.on('close', function() {
              return _this.request = original_request;
            });
          };
        })(this)), 0);
        return argument;
      }
    },
    miyopreview_demo_httpserver_stop: {
      type: 'through',
      filter: function(argument, request, id, stash) {
        this.variables_temporary.miyopreview_demo_httpserver_socket_io.close();
        delete this.variables_temporary.miyopreview_demo_httpserver_socket_io;
        delete this.variables_temporary.miyopreview_demo_httpserver_server;
        return argument;
      }
    },
    miyopreview_demo_httpserver_speak: {
      type: 'data-value',
      filter: function(argument, request, id, stash) {
        var options;
        options = argument.miyopreview_demo_httpserver_speak;
        this.dictionary.OnSecondChange = options.original;
        return options.content;
      }
    }
  };

}).call(this);
